#ifndef __HYDPSF_H__
#define __HYDPSF_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>

#include <iostream>
#include <vector>
#include <algorithm>

#include "HYParticleFilter.h"

using namespace std;

class HYDPsf : public HYParticleFilter{
 private:
  float zcenter,zrange,xcenter,xrange,rzcenter,rzrange;
  vector <float> points;
  float mnoise;
  int npoints,npoints_max;

  // for likelihod function
  vector <float> dist_f_list,dist_t_list;
  float me_k,ransac_r;

  float *plane_normal_front;
  float plane_d_front,plane_normal_front_norm;
  float *plane_normal_top;
  float plane_d_top,plane_normal_top_norm;

  //
  vector <float> on_plane_front_points,on_plane_top_points;

 public:
  HYDPsf(int np,float rr,float zc,float zr,float xc,float xr,float rzc,float rzr,float mn);
  ~HYDPsf();

  void predict();
  float likelihood(float *state);
  void stateToPlane(float *state);
  void setPoints(float *pts,int num);
  void setMeasurementNoise(float mn){mnoise=mn;}

  void stateToParam(float *state,float *param);

  void setZCenter(float zc){zcenter=zc;}
  void setZRange(float zr){zrange=zr;}
  void setXCenter(float xc){xcenter=xc;}
  void setXRange(float xr){xrange=xr;}
  void setRZCenter(float rzc){rzcenter=rzc;}
  void setRZRange(float rzr){rzrange=rzr;}

  float distancePlaneFront(float *point);
  void calcOnPlaneFront(float dt);
  int getOnPlaneFrontLength(){return on_plane_front_points.size();}
  float *getOnPlaneFront(){return &on_plane_front_points[0];}

  float distancePlaneTop(float *point);
  void calcOnPlaneTop(float dt);
  int getOnPlaneTopLength(){return on_plane_top_points.size();}
  float *getOnPlaneTop(){return &on_plane_top_points[0];}
};


#endif
